// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from hri_actions_msgs:action/FaceOverlay.idl
// generated code does not contain a copyright notice

#ifndef HRI_ACTIONS_MSGS__ACTION__DETAIL__FACE_OVERLAY__STRUCT_H_
#define HRI_ACTIONS_MSGS__ACTION__DETAIL__FACE_OVERLAY__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'BACKGROUND'.
/**
  * LAYER
  * display the image in the background (the eye's iris/pupil will be drawn on
  * top of the overlay
 */
enum
{
  hri_actions_msgs__action__FaceOverlay_Goal__BACKGROUND = 0
};

/// Constant 'FOREGROUND'.
/**
  * display the image on top of the eye (the eye's iris/pupil will be occluded by
  * the image, except where transparent)
 */
enum
{
  hri_actions_msgs__action__FaceOverlay_Goal__FOREGROUND = 1
};

/// Constant 'EXTEND'.
/**
  * LAYOUT
  * extend the provided image to cover both eyes.
  * Note: this typically is the only sensible option for robot with a single face panel
 */
enum
{
  hri_actions_msgs__action__FaceOverlay_Goal__EXTEND = 0
};

/// Constant 'COPY'.
/**
  * on robots with 2 panels (one per eye), copy the provided image onto each eye
 */
enum
{
  hri_actions_msgs__action__FaceOverlay_Goal__COPY = 1
};

/// Constant 'MIRROR'.
/**
  * on robots with 2 panels (one per eye), mirror the provided image onto each eyes (symmetry over the vertical axis)
 */
enum
{
  hri_actions_msgs__action__FaceOverlay_Goal__MIRROR = 2
};

/// Constant 'LEFT_EYE_ONLY'.
/**
  * on robots with 2 panels (one per eye), only display the image on the left eye
 */
enum
{
  hri_actions_msgs__action__FaceOverlay_Goal__LEFT_EYE_ONLY = 3
};

/// Constant 'RIGHT_EYE_ONLY'.
/**
  * on robots with 2 panels (one per eye), only display the image on the right eye
 */
enum
{
  hri_actions_msgs__action__FaceOverlay_Goal__RIGHT_EYE_ONLY = 4
};

// Include directives for member types
// Member 'media_url'
#include "rosidl_runtime_c/string.h"

/// Struct defined in action/FaceOverlay in the package hri_actions_msgs.
typedef struct hri_actions_msgs__action__FaceOverlay_Goal
{
  /// URL of the picture/animation to overlay on the face; currently only supports
  /// absolute local path
  rosidl_runtime_c__String media_url;
  /// duration, in seconds, of the overlay visibility
  /// - if the duration is larger than the duration of the animation, the animation
  /// will loop.
  /// - a duration of 0 means 'forever'. In this case, the action *will never
  /// complete* on its own. Cancelling the action will remove the overlay from the
  /// face.
  float duration;
  /// one of BACKGROUND or FOREGROUND
  uint8_t layer;
  /// one of the layout constant defined above
  uint8_t layout;
  /// scale of the image: 1.0 (default) means full width of the face/eye (depending
  /// on the chosen layout); 0.1 means 10% of the width.
  /// Note that any value <= 0.0 is ignored (replaced by 1.0)
  float scale;
  /// position offset, expressed as a proportion of the face or eye's width/height. Values
  /// in [-1.0, 1.0] range.
  ///
  /// (0.0, 0.0) means that the image is centered with the face/eye
  /// (-1.0, 1.0) means that the image's center would be located in the top left
  /// corner of the face/eye panel.
  float offset_x;
  float offset_y;
  /// EFFECTS
  /// if true, the overlay will fade in/fade out
  bool fade;
} hri_actions_msgs__action__FaceOverlay_Goal;

// Struct for a sequence of hri_actions_msgs__action__FaceOverlay_Goal.
typedef struct hri_actions_msgs__action__FaceOverlay_Goal__Sequence
{
  hri_actions_msgs__action__FaceOverlay_Goal * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_actions_msgs__action__FaceOverlay_Goal__Sequence;


// Constants defined in the message

/// Struct defined in action/FaceOverlay in the package hri_actions_msgs.
typedef struct hri_actions_msgs__action__FaceOverlay_Result
{
  uint8_t structure_needs_at_least_one_member;
} hri_actions_msgs__action__FaceOverlay_Result;

// Struct for a sequence of hri_actions_msgs__action__FaceOverlay_Result.
typedef struct hri_actions_msgs__action__FaceOverlay_Result__Sequence
{
  hri_actions_msgs__action__FaceOverlay_Result * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_actions_msgs__action__FaceOverlay_Result__Sequence;


// Constants defined in the message

/// Struct defined in action/FaceOverlay in the package hri_actions_msgs.
typedef struct hri_actions_msgs__action__FaceOverlay_Feedback
{
  uint8_t structure_needs_at_least_one_member;
} hri_actions_msgs__action__FaceOverlay_Feedback;

// Struct for a sequence of hri_actions_msgs__action__FaceOverlay_Feedback.
typedef struct hri_actions_msgs__action__FaceOverlay_Feedback__Sequence
{
  hri_actions_msgs__action__FaceOverlay_Feedback * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_actions_msgs__action__FaceOverlay_Feedback__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'goal'
#include "hri_actions_msgs/action/detail/face_overlay__struct.h"

/// Struct defined in action/FaceOverlay in the package hri_actions_msgs.
typedef struct hri_actions_msgs__action__FaceOverlay_SendGoal_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
  hri_actions_msgs__action__FaceOverlay_Goal goal;
} hri_actions_msgs__action__FaceOverlay_SendGoal_Request;

// Struct for a sequence of hri_actions_msgs__action__FaceOverlay_SendGoal_Request.
typedef struct hri_actions_msgs__action__FaceOverlay_SendGoal_Request__Sequence
{
  hri_actions_msgs__action__FaceOverlay_SendGoal_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_actions_msgs__action__FaceOverlay_SendGoal_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.h"

/// Struct defined in action/FaceOverlay in the package hri_actions_msgs.
typedef struct hri_actions_msgs__action__FaceOverlay_SendGoal_Response
{
  bool accepted;
  builtin_interfaces__msg__Time stamp;
} hri_actions_msgs__action__FaceOverlay_SendGoal_Response;

// Struct for a sequence of hri_actions_msgs__action__FaceOverlay_SendGoal_Response.
typedef struct hri_actions_msgs__action__FaceOverlay_SendGoal_Response__Sequence
{
  hri_actions_msgs__action__FaceOverlay_SendGoal_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_actions_msgs__action__FaceOverlay_SendGoal_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"

/// Struct defined in action/FaceOverlay in the package hri_actions_msgs.
typedef struct hri_actions_msgs__action__FaceOverlay_GetResult_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
} hri_actions_msgs__action__FaceOverlay_GetResult_Request;

// Struct for a sequence of hri_actions_msgs__action__FaceOverlay_GetResult_Request.
typedef struct hri_actions_msgs__action__FaceOverlay_GetResult_Request__Sequence
{
  hri_actions_msgs__action__FaceOverlay_GetResult_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_actions_msgs__action__FaceOverlay_GetResult_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'result'
// already included above
// #include "hri_actions_msgs/action/detail/face_overlay__struct.h"

/// Struct defined in action/FaceOverlay in the package hri_actions_msgs.
typedef struct hri_actions_msgs__action__FaceOverlay_GetResult_Response
{
  int8_t status;
  hri_actions_msgs__action__FaceOverlay_Result result;
} hri_actions_msgs__action__FaceOverlay_GetResult_Response;

// Struct for a sequence of hri_actions_msgs__action__FaceOverlay_GetResult_Response.
typedef struct hri_actions_msgs__action__FaceOverlay_GetResult_Response__Sequence
{
  hri_actions_msgs__action__FaceOverlay_GetResult_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_actions_msgs__action__FaceOverlay_GetResult_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'feedback'
// already included above
// #include "hri_actions_msgs/action/detail/face_overlay__struct.h"

/// Struct defined in action/FaceOverlay in the package hri_actions_msgs.
typedef struct hri_actions_msgs__action__FaceOverlay_FeedbackMessage
{
  unique_identifier_msgs__msg__UUID goal_id;
  hri_actions_msgs__action__FaceOverlay_Feedback feedback;
} hri_actions_msgs__action__FaceOverlay_FeedbackMessage;

// Struct for a sequence of hri_actions_msgs__action__FaceOverlay_FeedbackMessage.
typedef struct hri_actions_msgs__action__FaceOverlay_FeedbackMessage__Sequence
{
  hri_actions_msgs__action__FaceOverlay_FeedbackMessage * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_actions_msgs__action__FaceOverlay_FeedbackMessage__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // HRI_ACTIONS_MSGS__ACTION__DETAIL__FACE_OVERLAY__STRUCT_H_
